#ifndef TREE_H
#define TREE_H

enum half_tree_node_type {
	HALF_TREE_NODE_TYPE_BRANCH,
	HALF_TREE_NODE_TYPE_LEAF
};

struct half_tree_node {
	enum half_tree_node_type half_tree_node_type;

	struct half_tree_node* parent;
	/* points to own pointer held by parent
	 * necessary since this node might be a left, right, or parent and we
	 * can't really know, easier to manipulate own pointer to self
	 */
	struct half_tree_node** self_handle;

	struct half_tree_node* left;
	struct half_tree_node* right;
};

struct half_tree_node* half_tree_branch_create(
		struct half_tree_node* parent,
		struct half_tree_node** self_handle,
		struct half_tree_node* left,
		struct half_tree_node* right);
struct half_tree_node* half_tree_leaf_create(
		struct half_tree_node* parent,
		struct half_tree_node** self_handle);
/* does not destroy any children leaving them orphaned and potentially leaked
 * use half_tree_destroy for cleaning up (sub)trees
 */
void half_tree_node_destroy(struct half_tree_node*);
void half_tree_destroy(struct half_tree_node*);

/* insert node into an established tree
 * inserted node becomes the sibling of the insertion_point
 */
void half_tree_insert_node(
		struct half_tree_node* insertion_point,
		struct half_tree_node*);
void half_tree_remove_node(struct half_tree_node*);

/*
enum half_split_dir { HALF_SPLIT_HORIZONTAL, HALF_SPLIT_VERTICAL };

struct half_workspace {
	struct half_output* output;

	struct half_node* root;
	struct half_node* focused_node;

	struct wl_list link;
};
*/

#endif
