#include <signal.h>
#include <stdlib.h>

#include <wlr/util/log.h>

#include "server.h"

void termination_handler(int);

struct half_server* half_server;

int main() {
	// shut the server down cleanly on these signals
	signal(SIGTERM, termination_handler);
	signal(SIGINT, termination_handler);
	signal(SIGHUP, termination_handler);

	// TODO: configure logging level
	wlr_log_init(WLR_DEBUG, NULL);

	// try build a server that can be started and run
	half_server = half_server_create();
	if(!half_server) {
		return EXIT_FAILURE;
	}

	if(!half_server_start(half_server)) {
		half_server_destroy(half_server);
		return EXIT_FAILURE;
	}

	return EXIT_SUCCESS;
}

void termination_handler(int signal) {
	(void)signal;
	wl_display_terminate(half_server->wl_display);
}
